import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { GoodsAttrValue, GoodsAttrValueParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询商品属性值表
 */
export async function pageGoodsAttrValue(params: GoodsAttrValueParam) {
  const res = await request.get<ApiResult<PageResult<GoodsAttrValue>>>(
    MODULES_API_URL + '/shop/goods-attr-value/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品属性值表列表
 */
export async function listGoodsAttrValue(params?: GoodsAttrValueParam) {
  const res = await request.get<ApiResult<GoodsAttrValue[]>>(
    MODULES_API_URL + '/shop/goods-attr-value',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品属性值表
 */
export async function addGoodsAttrValue(data: GoodsAttrValue) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-attr-value',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品属性值表
 */
export async function updateGoodsAttrValue(data: GoodsAttrValue) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-attr-value',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品属性值表
 */
export async function removeGoodsAttrValue(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-attr-value/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品属性值表
 */
export async function removeBatchGoodsAttrValue(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-attr-value/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商品属性值表
 */
export async function getGoodsAttrValue(id: number) {
  const res = await request.get<ApiResult<GoodsAttrValue>>(
    MODULES_API_URL + '/shop/goods-attr-value/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
